/*=============================================================================
  =                     Common JavaScript functions                           =
  ============================================================================*/

function _template()
{
	try
	{
	
	} catch(e) {
		errorMessage(e);
	}		
}
/******************************************************************************
 *                      Common JavaScript constants                           *
 ******************************************************************************/
const BUTTON_LEFT = 0
/******************************************************************************
						Common JavaScript functions - Database
 ******************************************************************************/
function db_openDatabase(database)
{
	var dbConnection = null;
	try
	{
		if(database)
		{
			infoMessage(5, "db_openDatabase(): started: " + database.path);

			var ios				= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var sUri			= "file:///" + database.path;
			var uri				= ios.newURI(sUri, "", null);
			var nsifile			= uri.QueryInterface(Components.interfaces.nsIFileURL).file;
			var storageService	= Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);

			infoMessage(5, "db_openDatabase(): db path " + nsifile.path);

			dbConnection		= storageService.openDatabase(nsifile);
			
			infoMessage(5, "db_openDatabase(): db '" + dbConnection.databaseFile.path + "'; ready? " + dbConnection.connectionReady);
		} else {
			errorMessage("db_openDatabase(): No valid path to a database given!");
		}
	}
	catch(e)
	{
		errorMessage(e);
	}
	return dbConnection;
}

function db_closeDatabase(dbConnection)
{
	try
	{
		dbConnection.asyncClose();
	}
	catch(e)
	{
		errorMessage(e);
	}
}

function db_executeStatement(document, dbConnection, sql, fCompletion, oResultHandle)
{
	var aResult = null;
	try
	{
		infoMessage(5, "db_executeStatement(): started " + sql);

        if(sql)
        {
            var statement = dbConnection.createStatement(sql);
        
            // ATTENTION: This part is executed ASYNCHRONOUSLY! 
            statement.executeAsync(
                {
                    handleResult: 
                    function(aResultSet) 
                    {
                        infoMessage(5, "db_executeStatement(): handleResult: " + aResultSet);
                        aResult = aResultSet;
                        if(fCompletion)
                        {
                            fCompletion(document, aResultSet, oResultHandle);
                        }
                    },

                    handleError: 
                    function(aError) 
                    {
                        infoMessage(5, "db_executeStatement(): handleError: " + aError.message);
                        throw("Error: " + aError.message);
                    },

                    handleCompletion: 
                    function(aReason) 
                    {
                        infoMessage(5, "db_executeStatement(): handleCompletion: " + aReason);
                        if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
                        {
                            throw("Query canceled or aborted!");
                        } else {

                        }					
                    }
                }
            );
        } else {
            throw("No SQL statement given.");
        }
	}
	catch(e)
	{
		errorMessage(e);
	}
}


/*
function Sqlite()
        {
           this.dataBaseConnection = "";
        }

        Sqlite.prototype.openDataBase = function(dataBase)
        {
           var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
           file.append(dataBase);
           
           var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);
           this.dataBaseConnection = storageService.openDatabase(file);
        }

        Sqlite.prototype.retrieveData = function(query)
        {               
           var resultB = "";
           var rows = new Array(); // return ***

           if(this.dataBaseConnection != "")
           {
              var statement = this.dataBaseConnection.createStatement(query);
             
              statement.executeAsync
              ({
                 handleResult: function(aResultSet)
                 {
                    var i = 0;

        // ##########
                    //var rows = new Array(); // <-- How can I return this array? // return ***
        // ##########           

                    for (let row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow())
                    {
                       rows[i] = row;
                       ++i;
                    }
                 },
                               
                 handleError: function(anError)
                 {
                    alert("error");
                 },

                 handleCompletion: function(aReason)
                 {
                    if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED)
                         alert("error");
                 }
              });
           }
           return rows;  // return ***
        }

        var sq = new Sqlite();
        sq.openDataBase("test.sqlite");

        var result = sq.retrieveData("SELECT * FROM test");  //  returned rows ***

	    setTimeout(showResults, 0);
	   
	    function showResults() {
	        for (var j=0; j < result.length; j++) {
	             alert(result[j]);
	       }
	    }

*/

/******************************************************************************
						Common JavaScript functions - XPATH Handling
 *****************************************************************************/

function getXpathResult(document, xpath)
{
	var xpathresult = null;
	try
	{
		if(document && xpath)
		{
			infoMessage(5, "getXpathResult(): started: " + xpath);		
			xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			infoMessage(5, "getXpathResult(): finished with snapshot items: " + xpathresult.snapshotLength);
		}	
	} catch(e) {
		errorMessage(e);
	}
	return xpathresult;
}

function getHtmlOfXpath(document, xpath, expectedNoOfResults)
{
	var sXpathresult = null;
	try
	{
		if(document && xpath)
		{
			infoMessage(5, "getHtmlOfXpath(): started: " + xpath);		
			xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);			
			if(xpathresult && xpathresult.snapshotLength==1)
			{
				sXpathresult = xpathresult.snapshotItem(0).innerHTML;
				infoMessage(5, "getHtmlOfXpath(): " + sXpathresult);
			} else
			{
				errorMessage("getHtmlOfXpath(): No single XpathResult by xpath '" + xpath + "'; snapshotLength: " + xpathresult.snapshotLength);
			}
			infoMessage(5, "getHtmlOfXpath(): finished");
		}
	} catch (e) {
		errorMessage(e);
	}
	return sXpathresult;
}

function getNumberOfXpath(document, xpath, decimalPoint)
{
	var iXpathresult = null;
	try
	{
		if(document && xpath)
		{
			infoMessage(5, "getNumberOfXpath(): started: " + xpath);		
			xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);			
			if(xpathresult && xpathresult.snapshotLength==1)
			{
				iXpathresult = getNumberFromNode(xpathresult.snapshotItem(0).innerHTML, decimalPoint);
				infoMessage(5, "getNumberOfXpath(): " + iXpathresult);
			} else
			{
				errorMessage("getNumberOfXpath(): No single XpathResult by xpath '" + xpath + "'; snapshotLength: " + xpathresult.snapshotLength);
			}
			infoMessage(5, "getNumberOfXpath(): finished");
		}
	} catch (e) {
		errorMessage(e);
	}
	return iXpathresult;
}

function getHrefOfXpath(document, xpath)
{
	var iXpathresult = null;
	try
	{
		if(document && xpath)
		{
			infoMessage(5, "getHrefOfXpath(): started: " + xpath);		
			xpathresult = document.evaluate(xpath, document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);			
			if(xpathresult && xpathresult.snapshotLength==1)
			{
				iXpathresult = xpathresult.snapshotItem(0).getAttribute('href');
				infoMessage(5, "getHrefOfXpath(): " + iXpathresult);
			} else
			{
				errorMessage("getHrefOfXpath(): No single XpathResult by xpath '" + xpath + "'; snapshotLength: " + xpathresult.snapshotLength);
			}
			infoMessage(5, "getHrefOfXpath(): finished");
		}
	} catch (e) {
		errorMessage(e);
	}
	return iXpathresult;
}

function getTableByXpath(document, xpath)
{
	var table = null;
	try
	{
		if(document && xpath)
		{
			infoMessage(5, "getTableByXpath(): started: " + xpath);		
			xpathresult = getXpathResult(document, xpath);			
			if(xpathresult && xpathresult.snapshotLength==1)
			{
				table = get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "table");		
				infoMessage(5, "getTableByXpath(): " + table);
			} else
			{
				errorMessage("getTableByXpath(): No single XpathResult by xpath '" + xpath + "'; snapshotLength: " + xpathresult.snapshotLength);
			}
			infoMessage(5, "getTableByXpath(): finished");
		}
	} catch (e) {
		errorMessage(e);
	}
	return table;
}

function getXpathOfNode(GivenNode, checkForAttributes)
{
	infoMessage(0, "getXpathOfNode: started: " + GivenNode);
	if(GivenNode == null)
	{
		return null;
	}
	// declarations -----------------------------------------------
	var TempParent = null
	var Hierarchy = new Array()
	var StringBuffer = ""
	//-------------------------------------------------------------
	  
	// push first element on stack
	Hierarchy.push(GivenNode)
	  
	// search for all ancestors -----------------------------------
	var TempParent = GivenNode.parentNode
	var TempNode
	var TempSibling
	var PrevSiblings
	var Handled = false
	while(TempParent != null && TempParent.nodeType != Node.DOCUMENT_NODE)
	{
		Hierarchy.push(TempParent)
		TempParent = TempParent.parentNode
	}
	//-------------------------------------------------------------
	 
	// construct xpath
	while(!(Hierarchy.length == 0) && null != (TempNode = Hierarchy.pop()))
	{
		Handled = false
		// only consider elements
		if (TempNode.nodeType == Node.ELEMENT_NODE)
		{
			// is this the root element?
			if (StringBuffer.length == 0)
			{
				// root element - simply append element name
				StringBuffer = StringBuffer + '/' + TempNode.localName
			} else {
				// child element - append slash and element name
				StringBuffer = StringBuffer + "/" + TempNode.localName
				if (TempNode.hasAttributes() && checkForAttributes)
				{
					// see if the element has a name or id attribute
					if (TempNode.attributes.getNamedItem("id"))
					{
						StringBuffer = StringBuffer + "[@id='" + TempNode.attributes.getNamedItem("id").nodeValue + "']"
						Handled = true
					} else if (TempNode.attributes.getNamedItem("name"))
					{
						StringBuffer = StringBuffer + "[@name='" + TempNode.attributes.getNamedItem("name").nodeValue + "']"
						Handled = true
					}
				}
				if (!Handled)
				{
					// no known attribute we could use - get sibling index
					PrevSiblings = 1
					TempSibling = TempNode.previousSibling
					while (null != TempSibling)
					{
						if (TempSibling.nodeType == TempNode.nodeType)
						{
							if(TempSibling.localName.toLowerCase() == TempNode.localName.toLowerCase())
							{
								PrevSiblings++
							}
						}
						TempSibling = TempSibling.previousSibling
					}
					StringBuffer = StringBuffer + "[" + PrevSiblings + "]"
				}
			}
		}
	}
	// return buffer
	return StringBuffer
}

function getErrorBacktrace(e, location){
  try {
    location = location||false;
    var s = 'Backtrace: ';
    if(e.stack){
      var trace = e.stack.split('\n');
      for(var i=0; i<trace.length; i++)
      {
        trace[i]=trace[i].replace(/(.{0,})@(.{0,}):([\d]{1,})/gi,'$1�$2�$3').split('�');
      };
      // backtrace object incorrectly filled, fix it
      for(var i=trace.length-1; i>0; i--)
      {
        trace[i][0] = trace[i-1][0];
      };
      trace[0][0] = '['+e.message+']';
      for(var i=0; i<trace.length-1; i++)
      {
        s += szEntry.replace(/@line/i, (trace[i][2]||'unknown'))
                    .replace(/@file/i, (location?szEntryFile.replace(/@file/i,(trace[i][1]||(e.fileName||'unknown'))):''))
                    .replace(/@code/i, (trace[i][0]||'[statement source code not available]'));
      }
    }
    else if(e.lineNumber)
    {
      s += szEntry
            .replace(/@line/i, (e.lineNumber||'unknown'))
            .replace(/@file/i, (e.fileName||'unknown'))
            .replace(/@code/i, (e.message||e.toString()));
    }
    else
    {
      s = '[ Custom Error: \n\t' + e.toString();
    }
    return s+'\n';
  } catch(e) { 
      return e.toString(); 
  }
}

/******************************************************************************
						Common JavaScript functions - Logging
 *****************************************************************************/
function log_infoMessage(sInfoMessage)
{
	try
	{
    	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

		consoleService.logStringMessage(sInfoMessage);
	} catch(e) {
		errorMessage(e);
	}		
}