/******************************************************************************
 foxfm stadium objects
 *****************************************************************************/
infoMessage(1, "foxfm_stadium.js: loaded from: " + window.location.href);


function Foxfm_Stadium()
{
	try 
	{
		this.aBlocks = new Array();
	} catch (e) {
		errorMessage(e);
	}
}

function Foxfm_StadiumBlock()
{
	try
	{
		this.name;
		this.state;
		this.facility;
		this.seatsMax;
		this.seatsLeague;
		this.seatsFriendly;
		this.seatsCup;
		this.priceLeague;
		this.priceFriendly;
		this.priceCup;
	} catch (e) {
		errorMessage(e);
	}
}

function Foxfm_StadiumBlockName(document)
{
	try
	{
		this.aBlockNames;

		this.db_getBlockNames = function (document, aResult, object)
		{
			try
			{
				infoMessage(3, "Foxfm_StadiumBlockName.db_getBlockNames(): started: " + object.aBlockNames);
				
				if(aResult)
				{
					object.aBlockNames = new Array();
					var i=0;
					for(var row=aResult.getNextRow(); row; row=aResult.getNextRow()) 
					{
						var value = row.getResultByName("att_block_name");
						
						infoMessage(3, "db_getBlockNames(): " + i + ": " + value);
						object.aBlockNames[i] = value;
						i++;
					}
				} else {
					errorMessage("Foxfm_StadiumBlockName.db_getBlockNames(): Could not get stadium block names from the database.");
				}
			} catch (e) {
				errorMessage(e);
			}
			infoMessage(3, "db_getBlockNames(): finished: " + object.aBlockNames);
		};
		this.init = function()
		{
			try
			{
				var sql	= "SELECT att_block_name FROM tbl_block_name";
				foxfm_db_executeStatement(document, null, sql, this.db_getBlockNames, this);
			} catch (e) {
				errorMessage(e);
			}
		};
		this.init();
	} catch (e) {
		errorMessage(e);
	}
}

function Foxfm_StadiumBlockFacilities(document) 
{
	try 
	{
		this.aBlockFacilities = "test";

        /* This function is called when the SQLite statement finished executing
         * asynchronously. The parameter are the array containing the results
         * and the object where the results shall be save in.
         */
		this.db_getBlockFacilities = function (document, aResult, object)
		{
			try
			{
				infoMessage(3, "db_getBlockFacilities(): started: " + object.aBlockFacilities);
				
				if(aResult)
				{
					object.aBlockFacilities = new Array();
					var i=0;
					for(var row=aResult.getNextRow(); row; row=aResult.getNextRow()) 
					{
						var value = row.getResultByName("att_block_facility");
						
						infoMessage(3, "db_getBlockFacilities(): " + i + ": " + value);
						// = new Object();
						object.aBlockFacilities[i] = value;
						i++;
					}
				} else {
					errorMessage("db_getBlockFacilities(): Could not get stadium block facilities from the database.");
				}
			} catch (e) {
				errorMessage(e);
			}
			infoMessage(3, "db_getBlockFacilities(): finished: " + object.aBlockFacilities);
		};
		this.init = function()
		{
			try
			{
				
				var sql	= "SELECT att_block_facility FROM tbl_block_facility";
				foxfm_db_executeStatement(document, null, sql, this.db_getBlockFacilities, this);
			} catch (e) {
				errorMessage(e);
			}
		};
		
		this.init();
	} catch (e) {
		errorMessage(e);
	}
}

/******************************************************************************
 foxfm stadium globals
 *****************************************************************************/
// Initialisation due to asynchronous database access
var gStadium			= new Foxfm_Stadium();
var gBlockFacilities	= new Foxfm_StadiumBlockFacilities();
var gBlockNames			= new Foxfm_StadiumBlockName();

/******************************************************************************
 foxfm stadium functions
 *****************************************************************************/
function foxfm_stadium(document)
{
	try 
	{
		var addOverallPrices	= prefBranchOFMFunctionSettings.get("stadium.addOverallPrices");
		var addOffsetPrices		= prefBranchOFMFunctionSettings.get("stadium.addOffsetPrices");

		if(document.location.href.match("010_stadion/stadion.php") && addOverallPrices)
		{
			infoMessage(2, "foxfm_stadium(): start");
// foxfm_db_saveStadiumProperties(document);
			// get localisation strings
			var localeLeague				= foxfm_getLocale_league();
			var localeFriendly				= foxfm_getLocale_friendly();
			var localeCup					= foxfm_getLocale_cup();
			var localeChangeStadiumName		= foxfm_getLocale_ofmChangeStadiumName();
			var localeGeneralPriceLeague	= foxfm_getLocale_stadiumGeneralPriceLeague();
			var localeGeneralPriceFriendly	= foxfm_getLocale_stadiumGeneralPriceFriendly();
			var localeGeneralPriceCup		= foxfm_getLocale_stadiumGeneralPriceCup();
			
			var allTables					= document.getElementsByTagName("table");
			
			// add overall price table
			var searchStringStadiumTable	= localeChangeStadiumName;  // /Stadionname\s*\S*ndern/;
			var overallPricingTable = createPricingTable(document, "overall", 1, 69,
								localeGeneralPriceLeague, "<font color=\"black\">" + localeLeague + ":</font>",
								localeGeneralPriceFriendly, "<font color=\"black\">" + localeFriendly + ":</font>",
								localeGeneralPriceCup, "<font color=\"black\">" + localeCup + ":</font>");
								
			// find table where to put the pricing table
			var blockTableNo		= getTableNumber(document, searchStringStadiumTable);
			var blockTableCol		= getColumnNumber(document, searchStringStadiumTable);
			var blockTableRow		= getRowNumber(document, searchStringStadiumTable);
			infoMessage(3, "foxfm_stadium(): table(" + searchStringStadiumTable + "):" + blockTableNo + ", " + blockTableCol + ", " + blockTableRow);

			allTables[blockTableNo].rows[blockTableRow].insertCell(blockTableCol);				
			allTables[blockTableNo].rows[blockTableRow].cells[blockTableCol].appendChild(overallPricingTable);

			// add offset price table if activated
			if(addOffsetPrices)
			{
				var arrayTribune = new Array (/Nord-Trib\S*ne/, /Ost-Trib\S*ne/, /S\S*d-Trib\S*ne/, /West-Trib\S*ne/);
				var arrayTribuneXpath = new Array(
						"/html/body[1]/div[1]/form[1]/table[1]/tbody[1]/tr[1]/td[1]/table[1]/tbody[1]/tr[2]/td[1]/div[1]/table[1]/tbody[1]/tr[1]/td[1]/table[1]/tbody[1]/tr[1]/td[1]/div[1]/span[1]",
						"/html/body/div/form/table/tbody/tr/td/table/tbody/tr[2]/td[2]/div/table/tbody/tr/td/table/tbody/tr/td/div/b/font",
						"/html/body[1]/div[1]/form[1]/table[1]/tbody[1]/tr[1]/td[1]/table[1]/tbody[1]/tr[3]/td[1]/div[1]/table[1]/tbody[1]/tr[1]/td[1]/table[1]/tbody[1]/tr[1]/td[1]/div[1]/span[1]",
						"/html/body/div/form/table/tbody/tr/td/table/tbody/tr[3]/td[2]/div/table/tbody/tr/td/table/tbody/tr/td/div/b/font");
				for(var i=0; i<arrayTribune.length; i++)
				{
					// get localisation strings
					var localeOffset			= foxfm_getLocale_offset();
					var localeOffsetLeague		= foxfm_getLocale_stadiumOffsetLeague();
					var localeOffsetFriendly	= foxfm_getLocale_stadiumOffsetFriendly();
					var localeOffsetCup			= foxfm_getLocale_stadiumOffsetCup();

					var blockNumber = i + 1;
					var pricingTable = createPricingTable(document, "block" + blockNumber +"Offset", 0, 69,
										localeOffsetLeague, null,
										localeOffsetFriendly, null,
										localeOffsetCup, null);
										
					// find table where to put the pricing table
					var tribune				= arrayTribune[i];
					var tribuneXpath		= arrayTribuneXpath[i];
//					var blockTableNo		= getTableNumber(document, tribune);
					var tribuneTable		= getTableByXpath(document, tribuneXpath);
					var blockTableCol		= getColumnNumberByXPATH(document, tribuneXpath);
//					var blockTableCol		= getColumnNumber(document, tribune);
//					var blockTableRow		= getRowNumber(document, tribune);
					var blockTableRow		= getRowNumberByXPATH(document, tribuneXpath);

//					var lastRow		= allTables[blockTableNo].rows.length - 1;
					var lastRow		= tribuneTable.rows.length - 1;
//					var lastCell	= allTables[blockTableNo].rows[lastRow].insertCell(-1);
					var lastCell	= tribuneTable.rows[lastRow].insertCell(-1);
					var header		= createElement(document, "B", null, null, "minitext dsR42", null, null, null);
					lastCell.appendChild(header);
					var headerText	= document.createTextNode(localeOffset);
					header.appendChild(headerText);
				
					lastCell.appendChild(pricingTable);		
								
					// enlarge colspan of row containing name of tribune
//					allTables[blockTableNo].rows[blockTableRow].cells[blockTableCol].setAttribute("colspan", 6);
					tribuneTable.rows[blockTableRow].cells[blockTableCol].setAttribute("colspan", 6);
				}
									
				// change width of table containing stadium - find by attribute 'bgcolor' using XPath
				var result = document.evaluate( '//.[@bgcolor="#b8df8f"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
				infoMessage(2, "Number of stadium tables: " + result.snapshotLength);
				if(result.snapshotLength == 1)
				{
					result.snapshotItem(0).width = "806";
				}				
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

/*******************************************************************************
 * Name of function:		createPricingTable()
 * Arguments of function:	document
 * Description of function:	This function creates a new table with three rows
 *							containing each a dropdown. An event handler is 
 *							attached to each dropdown.
 */
function createPricingTable(document, block, ddMinPrice, ddMaxPrice,
							ddTooltipPriceLeague,	ddLabelPriceLeague,
							ddTooltipPriceFriendly,	ddLabelPriceFriendly,
							ddTooltipPriceCup,		ddLabelPriceCup
							)
{
	try
	{
		// get default price preferences
		var strPrefPriceLeague	= "stadium." + block + "PriceLeague";
		var strPrefPriceFriendly= "stadium." + block + "PriceFriendly";
		var strPrefPriceCup		= "stadium." + block + "PriceCup";

		var ddPrefPriceLeague	= prefBranchOFMFunctionSettings.get(strPrefPriceLeague);
		var ddPrefPriceFriendly	= prefBranchOFMFunctionSettings.get(strPrefPriceFriendly);
		var ddPrefPriceCup		= prefBranchOFMFunctionSettings.get(strPrefPriceCup);
		
		var newRowPriceLeague	= createRowStadiumPrice(document, "ddIdPriceLeague" + block		, ddMinPrice, ddMaxPrice, ddTooltipPriceLeague,		null, ddPrefPriceLeague,	ddLabelPriceLeague);		
		var newRowPriceFriendly	= createRowStadiumPrice(document, "ddIdPriceFriendly" + block	, ddMinPrice, ddMaxPrice, ddTooltipPriceFriendly,	null, ddPrefPriceFriendly,	ddLabelPriceFriendly);
		var newRowPriceCup		= createRowStadiumPrice(document, "ddIdPriceCup" + block		, ddMinPrice, ddMaxPrice, ddTooltipPriceCup,		null, ddPrefPriceCup,		ddLabelPriceCup);
		
		// attache event handler
		var ofmStadiumMinPrice = 0;
		var ofmStadiumMaxPrice = 68;
		newRowPriceLeague.addEventListener(		"change", function(event){eventStadiumPricing(event, strPrefPriceLeague,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);			
		newRowPriceFriendly.addEventListener(	"change", function(event){eventStadiumPricing(event, strPrefPriceFriendly,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		newRowPriceCup.addEventListener(		"change", function(event){eventStadiumPricing(event, strPrefPriceCup,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		
		newRowPriceLeague.addEventListener(		"keyup", function(event){eventStadiumPricing(event, strPrefPriceLeague,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);			
		newRowPriceFriendly.addEventListener(	"keyup", function(event){eventStadiumPricing(event, strPrefPriceFriendly,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		newRowPriceCup.addEventListener(		"keyup", function(event){eventStadiumPricing(event, strPrefPriceCup,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		
		// create pricing table
		var pricingTable 		= createTable(document, "dsR1", 0, 1);
				
		pricingTable.appendChild(newRowPriceLeague);
		pricingTable.appendChild(newRowPriceFriendly);
		pricingTable.appendChild(newRowPriceCup);
			
		return pricingTable;
	} catch (e) {
		errorMessage(e);
	}
}

function eventStadiumPricing(event, pref, minPrice, maxPrice)
{
	try
	{
		var document			= event.originalTarget.ownerDocument;
		var eventTargetNode 	= event.target;
		var eventType 			= event.type;
		var eventTargetId		= event.target.id;
		var eventKeycode		= event.keyCode;
		var newPrice=0, offsetPrice=0;

		infoMessage(3, "eventStadiumPricing(): started: " + eventType + "; pref: " + pref);

		// run this handler only on mouse or arrow keys (keyocde: 37-40) events
		if(!eventKeycode || (eventKeycode>=37 && eventKeycode<=40))
		{
			infoMessage(3, "eventStadiumPricing(): event type: " + eventType + "; node name: " + eventTargetNode.nodeName + "; key code: " + eventKeycode);
			
			// get type of game (L, F, C) and number of block
			var gameType			= getTypeOfGame(eventTargetId);
			var blockOfStadium		= getStadiumBlock(eventTargetId);
			
			// get overall ticket price
			var overallPrice		= document.getElementById("ddIdPrice" + gameType + "overall").selectedIndex;		

			infoMessage(3, "eventStadiumPricing(): " + gameType + " Block " + blockOfStadium);			

			if(blockOfStadium)
			{
				/* handle changes of the offset price */
				offsetPrice = getStadiumOffsetStadiumPriceOfBlock(document, gameType, blockOfStadium);
				newPrice	= coerce(minPrice, maxPrice, overallPrice + offsetPrice);
				setStadiumPriceOfBlock(document, gameType, blockOfStadium, newPrice);
				prefBranchOFMFunctionSettings.set(pref, offsetPrice.toString());
			} else {
				/* handle changes of the overall price */
				for(var i=1; i<5; i++)
				{
					offsetPrice = getStadiumOffsetStadiumPriceOfBlock(document, gameType, i);
					newPrice	= coerce(minPrice, maxPrice, overallPrice + offsetPrice);
					setStadiumPriceOfBlock(document, gameType, i, newPrice);
					prefBranchOFMFunctionSettings.set(pref, overallPrice.toString());
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function getStadiumOffsetStadiumPriceOfBlock(document, gameType, block)
{
	try
	{
		var offsetPrice		= 0;
		var idOfOffsetPrice	= "ddIdPrice" + gameType + "block" + block + "Offset";
		
		if(document.getElementById(idOfOffsetPrice))
		{
			offsetPrice	= document.getElementById(idOfOffsetPrice).selectedIndex;
		} else {
			offsetPrice = 0;
		}
		
		infoMessage(4, "getStadiumOffsetStadiumPriceOfBlock(): gameType: " + gameType + ", block: " + block + ", offsetPrice: " + offsetPrice);
		
		return offsetPrice;
	} catch (e) {
		errorMessage(e);
	}
}

function setStadiumPriceOfBlock(document, gameType, block, price)
{
	try
	{
		switch (gameType) 
		{
			case "League":
				newBlockCore = "block" + block;
				break;
			case "Friendly":
				newBlockCore = "block" + block + "fr";
				break;
			case "Cup":
				newBlockCore = "block" + block + "pok";
				break;
		}
		document.getElementsByName(newBlockCore)[0].options[price].selected = true;
	} catch (e) {
		errorMessage(e);
	}
}

function createDropDownPrice(document, dropdownId, dropdownRangeMin, dropdownRangeMax, dropdownTooltip, dropdownOnchange, dropdownDefault)
{
	try
	{
		infoMessage(3, "createDropDownPrice(): started");

		var newSelect = createDropdown(document, dropdownId, null, "forminput_60px", "{width:50px;}", dropdownTooltip, dropdownOnchange);
		for(var i=dropdownRangeMin;i<=dropdownRangeMax;i++)
		{
			var localeCurrencySign	= foxfm_getLocale_currencySign();
			var newOption	= document.createElement('option');
			newOption.text	= i + localeCurrencySign;
			newOption.id	= dropdownId + "_" + i;
			newSelect.add(newOption, null);
		}
		if(dropdownDefault<dropdownRangeMax)
		{
			newSelect.options[dropdownDefault].defaultSelected = true;
		}
		return newSelect;
	} catch (e) {
		errorMessage(e);
	}
}

function createRowStadiumPrice(document, selectId, selectMin, selectMax, selectTooltip, selectOnchange, selectDefault, label)
{
	try
	{
		infoMessage(3, "createRowStadiumPrice(): started");
		
		var newRow 				= createRow(document, null, null);
		var newCellLabel 		= createCell(document, null, null, null, label, null, "minitext");
		var newCellDropdown 	= createCell(document, null, null, null, null, null, null);
		var newSelect 			= createDropDownPrice(document, selectId, selectMin, selectMax, selectTooltip, selectOnchange, selectDefault);
		var newInput			= createElement(document, "input", "hidden" + selectId, null, null, null, null, null);
		newInput.setAttribute("type", "hidden");
		
		newCellDropdown.appendChild(newSelect);
		newCellDropdown.appendChild(newInput);

		newRow.appendChild(newCellLabel);
		newRow.appendChild(newCellDropdown);
		
		return newRow;
	} catch (e) {
		errorMessage(e);
	}
}

function getBlockProperties(document, block)
{
	try
	{
		infoMessage(0, "getBlockProperties(): started: " + block.name);
		if(document && block)
		{
			var allTables		= document.getElementsByTagName("table");
			var tableOfBlockNo	= findTableByRegExp(allTables, block.name);
			if(tableOfBlockNo && tableOfBlockNo.length==1)
			{
				infoMessage(3, "getBlockProperties(): " + tableOfBlockNo[0]["table"]);
				var tableOfBlockObject			= allTables[tableOfBlockNo[0]["table"]];
				block.seatsMax		= getBlockPropertySeats(tableOfBlockObject, /Pl\Stze/);
				block.seatsLeague	= getBlockPropertySeats(tableOfBlockObject, /letztes Liga-Spiel/);
				block.seatsFriendly	= getBlockPropertySeats(tableOfBlockObject, /letztes Fr.-Spiel/);
				block.seatsCup		= getBlockPropertySeats(tableOfBlockObject, /letztes Pokal-Spiel/);
				block.state			= getBlockPropertySeats(tableOfBlockObject, /Zustand/);
				block.priceLeague	= getBlockPropertyPrice(tableOfBlockObject, /Liga/);
				block.priceFriendly	= getBlockPropertyPrice(tableOfBlockObject, /Friendly/);
				block.priceCup		= getBlockPropertyPrice(tableOfBlockObject, /OFM-Pokal/);
				var aFacilities		= gBlockFacilities.aBlockFacilities;
				infoMessage(3, "getBlockProperties(): aFacilities: " + aFacilities);		
				block.facility		= getBlockPropertyFacility(tableOfBlockObject, aFacilities);
			} else {
				errorMessage("getBlockProperties(): Could not determine properties of block '" + block.name + "'.");
			}
		}
		infoMessage(3, "getBlockProperties(): finished");		
	} catch (e) {
		errorMessage(e);
	}
	return block;
}

function getBlockPropertySeats(table, property)
{
	var blockProperty = null;
	try
	{
		infoMessage(4, "getBlockPropertySeats(): started: " + property);
		var result = scanTableByRegExp(table, property);
		if(result && result.length==1)
		{
			blockProperty = getNumberFromNode(table.rows[result[0]["row"]].cells[result[0]["cell"]+1]);
			infoMessage(0, "getBlockPropertySeats(): " + blockProperty);
		} else {
			errorMessage("getBlockPropertySeats(): Could not determine the property '" + property + "'.");
		}
		infoMessage(4, "getBlockPropertySeats(): finished");
	} catch (e) {
		errorMessage(e);
	}
	return blockProperty;
}

function getBlockPropertyFacility(table, aFacilities)
{
	var blockFacility = null;
	try
	{
		for(var i=0; i<aFacilities.length; i++)
		{
			var facility = aFacilities[i];
			infoMessage(4, "getBlockPropertyFacility(): started: " + facility);
			var result = scanTableByRegExp(table, facility);
			if(result && result.length==1)
			{
				var aNodes = table.rows[result[0]["row"]].cells[result[0]["cell"]].childNodes;
				blockFacility = scanChildNodes(aNodes, facility);			
				infoMessage(4, "getBlockPropertyFacility(): block facility " + blockFacility);
			}
		}
		if(!blockFacility)
		{
			errorMessage("getBlockPropertyFacility(): Could not determine the block facility.");
		}
		infoMessage(4, "getBlockPropertyFacility(): finished");
	} catch (e) {
		errorMessage(e);
	}
	return blockFacility;
}

function getBlockPropertyPrice(tblBlock, kindOfGame)
{
	var blockPrice = null;
	try
	{
		infoMessage(4, "getBlockPropertyPrice(): started: " + kindOfGame);
		
		var aTblsOfBlock	= tblBlock.getElementsByTagName("table");
		if(aTblsOfBlock && aTblsOfBlock.length>0)
		{
			var tblBlockPrice	= findTableByRegExp(aTblsOfBlock, kindOfGame);
			if(tblBlockPrice && tblBlockPrice.length==1)
			{
				var tbl			= tblBlockPrice[0]["table"];
				var row			= tblBlockPrice[0]["row"];
				var cell		= tblBlockPrice[0]["cell"];
				var selectPrice	= aTblsOfBlock[tbl].rows[row].cells[cell+1].getElementsByTagName("select");
				if(selectPrice && selectPrice.length==1)
				{
					blockPrice	= selectPrice[0].selectedIndex + 1;
					infoMessage(4, "getBlockPropertyPrice(): " + blockPrice);
				} else {
					throw("getBlockPropertyPrice(): Could not find the SELECT-element containing the price of '" + kindOfGame + "'.");
				}
			} else {
				throw("getBlockPropertyPrice(): Could not find the TABLE-element containing the price of '" + kindOfGame + "'.");				
			}
		} else {
			throw("getBlockPropertyPrice(): Could not find any sub-table of the block related to the price of '" + kindOfGame + "'.");
		}
		infoMessage(4, "getBlockPropertyPrice(): finished");
	} catch (e) {
		errorMessage(e);
	}
	return blockPrice;
}

/*******************************************************************************
 * Name of function:		foxfm_db_saveStadiumProperties()
 * Arguments of function:	document
 * Description of function:	This function saves the prices of the stadium into
 *							the database.
 */
 function foxfm_db_saveStadiumProperties(document)
{
	try
	{
		gStadium.aBlocks = new Array();

		// get the properties of the different stadium sections
		for(var i=0; i<gBlockNames.aBlockNames.length; i++)
		{
			gStadium.aBlocks[i]			= new Foxfm_StadiumBlock();
			gStadium.aBlocks[i].name	= gBlockNames.aBlockNames[i];
			gStadium.aBlocks[i]			= getBlockProperties(document, gStadium.aBlocks[i]);
			infoMessage(0, "foxfm_db_saveStadiumProperties(): " + gStadium.aBlocks[i].facility);
		}
		// get the current season
		
		// get the current match day
		infoMessage(0, "foxfm_db_saveStadiumProperties(): day: " + gMatchday.day);
		infoMessage(0, "foxfm_db_saveStadiumProperties(): season: " + gMatchday.season);

		
		// connect to database and save block properties
	} catch(e) {
		errorMessage(e);
	}
}

/*******************************************************************************
 * Name of function:		foxfm_db_saveStadiumEnvironment()
 * Arguments of function:	document
 * Description of function:	This function saves the envirionement of the 
 *							stadium into the database:
 *							- floodlight
 *							- display
 *							- security
 *							- car park
 */
 function foxfm_db_saveStadiumEnvironment()
{
	try
	{
		infoMessage(0, "foxfm_db_saveStadiumEnvironment(): started");

		// get the environment values of the stadium
		
		// get the current season
		
		// get the current match day
		
		// connect to database and save environment
		infoMessage(0, "foxfm_db_saveStadiumEnvironment(): finished");
	} catch(e) {
		errorMessage(e);
	}
}